﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Telerik.WinControls.UI;

namespace _858695_RadGridView
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            GridViewDateTimeColumn dateTimeColumn = new GridViewDateTimeColumn();
            dateTimeColumn.Name = "DateTimeColumn";
            dateTimeColumn.HeaderText = "Order date";
            dateTimeColumn.FieldName = "OrderDate";
            dateTimeColumn.Width = 200;
            dateTimeColumn.Format = DateTimePickerFormat.Custom;
            dateTimeColumn.CustomFormat = "yyyy/MM/dd";
            dateTimeColumn.FormatString = "{0:yyyy/MM/dd}";
            radGridView1.MasterTemplate.Columns.Add(dateTimeColumn);

            for (int i = 0; i < 3; i++)
            {
                this.radGridView1.Rows.Add(DateTime.Now.AddHours(i), DateTime.Now.AddHours(i));
            }

            this.radGridView1.CellEditorInitialized += radGridView1_CellEditorInitialized;
        }

        void radGridView1_CellEditorInitialized(object sender, GridViewCellEventArgs e)
        {
            if (e.Column is GridViewDateTimeColumn)
            {
                RadDateTimeEditor editor = e.ActiveEditor as RadDateTimeEditor;
                editor.CustomFormat = "yyyyMMdd";

                RadDateTimeEditorElement element = editor.EditorElement as RadDateTimeEditorElement;
                MaskDateTimeProvider provider = element.TextBoxElement.Provider as MaskDateTimeProvider;
                provider.TextBoxItem.KeyUp -= TextBoxItem_KeyUp;
                provider.TextBoxItem.KeyUp += TextBoxItem_KeyUp;              
            }
        }

        private int day = 0;
        private int month = 0;
        private int year = 0;

        void TextBoxItem_KeyUp(object sender, KeyEventArgs e)
        {
            if ((e.KeyCode >= Keys.D0 && e.KeyCode <= Keys.D9) || (e.KeyCode >= Keys.NumPad0 && e.KeyCode <= Keys.NumPad9) || e.KeyCode == Keys.Decimal)
            {
                RadTextBoxItem item = sender as RadTextBoxItem;
                RadMaskedEditBoxElement element = item.Parent as RadMaskedEditBoxElement;
                MaskDateTimeProvider provider = element.Provider as MaskDateTimeProvider;

                switch (provider.List[provider.SelectedItemIndex].type)
                {
                    case PartTypes.Day:
                        day += 1;
                        break;
                    case PartTypes.Month:
                        month += 1;
                        break;
                    case PartTypes.Year:
                        year += 1;
                        break;
                }

                if (year == 4)
                {
                    provider.SelectNextEditableItem();
                    year = 0;
                }
                if (month == 2)
                {
                    provider.SelectNextEditableItem();
                    month = 0;
                }
                if (day == 2)
                {
                    provider.SelectNextEditableItem();
                    day = 0;
                }
            }
            else if (e.KeyData == Keys.Left || e.KeyData == Keys.Right || e.KeyData == Keys.Divide)
            {
                day = 0;
                month = 0;
                year = 0;
            }
        }
    }
}
